-- Time-stamp: <2006-12-08 16:13:36 cklin>

module Infopipes.Utils where

import Control.Monad
import Data.List
import Infopipes.Syntax

--

once :: Eq a => [a] -> [a]
once xs = uxs \\ (xs \\ uxs) where uxs = nub xs

cartesian :: [[a]] -> [[a]]
cartesian = foldr (liftM2 (:)) [[]]

unions xs = foldl union [] xs
intersects xs = foldl1 intersect xs

commas = concat . intersperse ", "

